require_relative 'utils.rb'
require 'faraday'
require 'json'

utils = Utils.new('uid=admin', 'password')
options = { ca_file: utils.ca_pem }
jwt = utils.authenticate
hdap = Faraday.new(url: "https://#{utils.host}:#{utils.port}/hdap/", ssl: options) do |f|
    f.headers['Content-Type'] = 'application/json'
    f.request :authorization, 'Bearer', jwt
end
body = {
    "_id" => "dc=com/dc=example/cn=Lockout%20with%20max%20age%20and%20grace%20logins",
    "objectClass" => ["top", "subentry", "ds-pwp-password-policy"],
    "cn" => ["Lockout with max age and grace logins"],
    "ds-pwp-default-password-storage-scheme" => ["PBKDF2-HMAC-SHA256"],
    "ds-pwp-grace-login-count" => 3,
    "ds-pwp-lockout-duration" => "5 m",
    "ds-pwp-lockout-failure-count" => 3,
    "ds-pwp-lockout-failure-expiration-interval" => "10 m",
    "ds-pwp-max-password-age" => "30 d",
    "ds-pwp-password-attribute" => "userPassword",
    "subtreeSpecification" => { "base": "ou=people", "filter": "/uid eq \"bjensen\"" }
}
response = hdap.post do |h|
    h.path = 'dc=com/dc=example'
    h.body = JSON.generate(body)
end

puts "Status code: #{response.status}\nJSON: #{response.body}"
